<template>
  <div>
    <div class="auth__title">{{ $t('auth.login') }}</div>
    <form class="auth__form" @submit.prevent="onSubmit">
      <div class="auth__row">
        <div class="auth__half">
          <el-input
            v-model="form.login"
            type="text"
            :placeholder="$t('email')"
          />
        </div>
        <div class="auth__half">
          <div class="auth__reset">
            <el-input
              v-model="form.password"
              type="password"
              :placeholder="$t('password')"
              classes="input-forgot"
            />
            <nuxt-link :to="localePath('/auth/forgot')">
              {{ $t('auth.forgot') }}
            </nuxt-link>
          </div>
        </div>
        <div class="auth__full">
          <Button variant="success">
            {{ $t('auth.loginBtn') }}
          </Button>
        </div>
        <!-- <div class="auth__full">
          <Button class="auth__google" variant="light">
            <svg-icon name="google" />
            <span>
              {{ $t('auth.login_with_google') }}
            </span>
          </Button>
        </div> -->
      </div>
    </form>
    <Alert v-if="error" variant="danger">
      {{ $t('errors.' + error) }}
    </Alert>
    <!-- <div class="auth__connect">
      <div class="auth__connect_title">
        {{ $t('auth.easy_way') }}
      </div>
      <div class="auth__row">
        <div class="auth__half">
          <Button class="auth__google" variant="light">
            <svg-icon name="google" />
            <span>
              {{ $t('auth.login_with_google') }}
            </span>
          </Button>
        </div>
      </div>
    </div> -->
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  reactive,
  ref,
  useContext
} from '@nuxtjs/composition-api'

import elInput from '@/components/element/Input.vue'
import Button from '@/components/ui/Button.vue'
import Alert from '@/components/ui/Alert.vue'

import isEmail from 'validator/lib/isEmail'

import type { ErrorKey } from '@/lang/en-US'

export default defineComponent({
  layout: 'auth',
  name: 'AuthLoginPage',
  components: { elInput, Button, Alert },
  setup() {
    const form = reactive({
      login: '',
      password: ''
    })

    const error = ref<ErrorKey | null>(null)

    const { app } = useContext()

    async function onSubmit() {
      if (!isEmail(form.login)) {
        error.value = 'email_not_valid'
        return
      }

      if (form.password.length < 8) {
        error.value = 'password_not_valid'
        return
      }

      try {
        await app.$api.auth.login(form.login, form.password)
        error.value = null
      } catch (err) {
        // eslint-disable-next-line no-console
        console.log(err?.response?.data)
        switch (err?.response?.data?.message) {
          case 'Account does not exist.':
            error.value = 'account_does_not_exist'
            break

          default:
            error.value = 'oops'
            break
        }
      }
    }

    return { form, error, onSubmit }
  }
})
</script>
